
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>emulsion.tools.parallel &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="../../../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="../../../_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
   
  <link rel="stylesheet" href="../../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for emulsion.tools.parallel</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;A Python implementation of the EMuLSion framework (Epidemiologic</span>
<span class="sd">MUlti-Level SImulatiONs).</span>

<span class="sd">Tools for parallel computing.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="c1"># [HEADER]</span>


<span class="kn">import</span> <span class="nn">multiprocessing</span>           <span class="k">as</span>     <span class="nn">mp</span>

<span class="kn">from</span>   <span class="nn">emulsion.tools.simulation</span> <span class="k">import</span> <span class="n">MultiSimulation</span><span class="p">,</span> <span class="n">SensitivitySimulation</span>

<div class="viewcode-block" id="job_dist"><a class="viewcode-back" href="../../../emulsion.tools.html#emulsion.tools.parallel.job_dist">[docs]</a><span class="k">def</span> <span class="nf">job_dist</span><span class="p">(</span><span class="n">total_task</span><span class="p">,</span> <span class="n">workers</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Return a distribution of each worker need to do.</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">nb</span> <span class="o">=</span> <span class="n">total_task</span> <span class="o">//</span> <span class="n">workers</span>
    <span class="n">rest</span> <span class="o">=</span> <span class="n">total_task</span> <span class="o">%</span> <span class="n">workers</span>
    <span class="k">return</span> <span class="p">[</span><span class="n">nb</span><span class="o">+</span><span class="mi">1</span> <span class="k">if</span> <span class="n">i</span> <span class="o">&lt;=</span> <span class="n">rest</span><span class="o">-</span><span class="mi">1</span> <span class="k">else</span> <span class="n">nb</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">workers</span><span class="p">)]</span></div>

<div class="viewcode-block" id="job"><a class="viewcode-back" href="../../../emulsion.tools.html#emulsion.tools.parallel.job">[docs]</a><span class="k">def</span> <span class="nf">job</span><span class="p">(</span><span class="n">target_simulation_class</span><span class="p">,</span> <span class="n">proc</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Simple job for a simple processes</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">simu</span> <span class="o">=</span> <span class="n">target_simulation_class</span><span class="p">(</span><span class="n">proc</span><span class="o">=</span><span class="n">proc</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">)</span>
    <span class="n">simu</span><span class="o">.</span><span class="n">run</span><span class="p">()</span>
    <span class="n">simu</span><span class="o">.</span><span class="n">write_dot</span><span class="p">()</span></div>
    <span class="c1"># simu.counts_to_csv()</span>

<div class="viewcode-block" id="parallel_multi"><a class="viewcode-back" href="../../../emulsion.tools.html#emulsion.tools.parallel.parallel_multi">[docs]</a><span class="k">def</span> <span class="nf">parallel_multi</span><span class="p">(</span><span class="n">target_simulation_class</span><span class="o">=</span><span class="n">MultiSimulation</span><span class="p">,</span> <span class="n">nb_simu</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                   <span class="n">nb_proc</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Parallel loop for distributing tasks in different processes</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">list_proc</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">list_nb_simu</span> <span class="o">=</span> <span class="n">job_dist</span><span class="p">(</span><span class="n">nb_simu</span><span class="p">,</span> <span class="n">nb_proc</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nb_proc</span><span class="p">):</span>
        <span class="n">others</span><span class="p">[</span><span class="s1">&#39;nb_simu&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">list_nb_simu</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
        <span class="n">others</span><span class="p">[</span><span class="s1">&#39;start_id&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">list_nb_simu</span><span class="p">[:</span><span class="n">i</span><span class="p">])</span>
        <span class="n">proc</span> <span class="o">=</span> <span class="n">mp</span><span class="o">.</span><span class="n">Process</span><span class="p">(</span><span class="n">target</span><span class="o">=</span><span class="n">job</span><span class="p">,</span> <span class="n">args</span><span class="o">=</span><span class="p">(</span><span class="n">target_simulation_class</span><span class="p">,</span> <span class="n">i</span><span class="p">),</span>
                          <span class="n">kwargs</span><span class="o">=</span><span class="n">others</span><span class="p">)</span>
        <span class="n">list_proc</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">proc</span><span class="p">)</span>
        <span class="n">proc</span><span class="o">.</span><span class="n">start</span><span class="p">()</span>

    <span class="k">for</span> <span class="n">proc</span> <span class="ow">in</span> <span class="n">list_proc</span><span class="p">:</span>
        <span class="n">proc</span><span class="o">.</span><span class="n">join</span><span class="p">()</span></div>

<div class="viewcode-block" id="parallel_sensi"><a class="viewcode-back" href="../../../emulsion.tools.html#emulsion.tools.parallel.parallel_sensi">[docs]</a><span class="k">def</span> <span class="nf">parallel_sensi</span><span class="p">(</span><span class="n">target_simulation_class</span><span class="o">=</span><span class="n">SensitivitySimulation</span><span class="p">,</span> <span class="n">nb_proc</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                   <span class="o">**</span><span class="n">others</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Parallel loop for distributing sensitivity tasks in different processes</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">list_proc</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">list_nb_simu</span> <span class="o">=</span> <span class="n">job_dist</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">others</span><span class="p">[</span><span class="s1">&#39;df&#39;</span><span class="p">]),</span> <span class="n">nb_proc</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nb_proc</span><span class="p">):</span>
        <span class="n">others</span><span class="p">[</span><span class="s1">&#39;nb_multi&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">list_nb_simu</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
        <span class="n">others</span><span class="p">[</span><span class="s1">&#39;start_id&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">list_nb_simu</span><span class="p">[:</span><span class="n">i</span><span class="p">])</span>
        <span class="n">proc</span> <span class="o">=</span> <span class="n">mp</span><span class="o">.</span><span class="n">Process</span><span class="p">(</span><span class="n">target</span><span class="o">=</span><span class="n">job</span><span class="p">,</span> <span class="n">args</span><span class="o">=</span><span class="p">(</span><span class="n">target_simulation_class</span><span class="p">,</span> <span class="n">i</span><span class="p">),</span>
                          <span class="n">kwargs</span><span class="o">=</span><span class="n">others</span><span class="p">)</span>
        <span class="n">list_proc</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">proc</span><span class="p">)</span>
        <span class="n">proc</span><span class="o">.</span><span class="n">start</span><span class="p">()</span>

    <span class="k">for</span> <span class="n">proc</span> <span class="ow">in</span> <span class="n">list_proc</span><span class="p">:</span>
        <span class="n">proc</span><span class="o">.</span><span class="n">join</span><span class="p">()</span></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../index.html">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../index.html">Documentation overview</a><ul>
  <li><a href="../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
    </div>

    

    
  </body>
</html>